using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

namespace SampleCs
{
	/// <summary>
	/// Summary description for BatchOptions.
	/// </summary>
	public class BatchOptions : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.TextBox sizeTextBox;
		private System.Windows.Forms.Label FontSizeLabel;
		private System.Windows.Forms.CheckBox sizeCheckBox;
		private System.Windows.Forms.Button OKButton;
		private System.Windows.Forms.CheckBox PrintCheckBox;
		private System.Windows.Forms.Button cancelButton;
		private System.Windows.Forms.CheckBox whitespaceCheckBox;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public BatchOptions()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			
			SampleFrame.newFontSize = -1;
			SampleFrame.printWhileConverting = false;
			SampleFrame.removeWhitespace = false;

			

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.label1 = new System.Windows.Forms.Label();
			this.sizeTextBox = new System.Windows.Forms.TextBox();
			this.FontSizeLabel = new System.Windows.Forms.Label();
			this.sizeCheckBox = new System.Windows.Forms.CheckBox();
			this.OKButton = new System.Windows.Forms.Button();
			this.PrintCheckBox = new System.Windows.Forms.CheckBox();
			this.cancelButton = new System.Windows.Forms.Button();
			this.whitespaceCheckBox = new System.Windows.Forms.CheckBox();
			this.SuspendLayout();
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(8, 8);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(296, 40);
			this.label1.TabIndex = 0;
			this.label1.Text = "This batch process will convert the font in all these files to the one you specif" +
				"y. It will save all files in the RTF Format.";
			// 
			// sizeTextBox
			// 
			this.sizeTextBox.Location = new System.Drawing.Point(236, 56);
			this.sizeTextBox.Name = "sizeTextBox";
			this.sizeTextBox.Size = new System.Drawing.Size(64, 20);
			this.sizeTextBox.TabIndex = 1;
			this.sizeTextBox.Text = "8";
			// 
			// FontSizeLabel
			// 
			this.FontSizeLabel.Location = new System.Drawing.Point(152, 60);
			this.FontSizeLabel.Name = "FontSizeLabel";
			this.FontSizeLabel.Size = new System.Drawing.Size(84, 16);
			this.FontSizeLabel.TabIndex = 2;
			this.FontSizeLabel.Text = "New Font Size:";
			// 
			// sizeCheckBox
			// 
			this.sizeCheckBox.Checked = true;
			this.sizeCheckBox.CheckState = System.Windows.Forms.CheckState.Checked;
			this.sizeCheckBox.Location = new System.Drawing.Point(8, 56);
			this.sizeCheckBox.Name = "sizeCheckBox";
			this.sizeCheckBox.Size = new System.Drawing.Size(128, 24);
			this.sizeCheckBox.TabIndex = 4;
			this.sizeCheckBox.Text = "Change the font size";
			this.sizeCheckBox.CheckedChanged += new System.EventHandler(this.sizeCheckBox_CheckedChanged);
			// 
			// OKButton
			// 
			this.OKButton.Location = new System.Drawing.Point(168, 152);
			this.OKButton.Name = "OKButton";
			this.OKButton.TabIndex = 8;
			this.OKButton.Text = "OK";
			this.OKButton.Click += new System.EventHandler(this.OKButton_Click);
			// 
			// PrintCheckBox
			// 
			this.PrintCheckBox.Location = new System.Drawing.Point(8, 120);
			this.PrintCheckBox.Name = "PrintCheckBox";
			this.PrintCheckBox.TabIndex = 7;
			this.PrintCheckBox.Text = "Print all files";
			// 
			// cancelButton
			// 
			this.cancelButton.Location = new System.Drawing.Point(72, 152);
			this.cancelButton.Name = "cancelButton";
			this.cancelButton.TabIndex = 9;
			this.cancelButton.Text = "Cancel";
			this.cancelButton.Click += new System.EventHandler(this.cancelButton_Click);
			// 
			// whitespaceCheckBox
			// 
			this.whitespaceCheckBox.Checked = true;
			this.whitespaceCheckBox.CheckState = System.Windows.Forms.CheckState.Checked;
			this.whitespaceCheckBox.Location = new System.Drawing.Point(8, 88);
			this.whitespaceCheckBox.Name = "whitespaceCheckBox";
			this.whitespaceCheckBox.Size = new System.Drawing.Size(148, 24);
			this.whitespaceCheckBox.TabIndex = 10;
			this.whitespaceCheckBox.Text = "Trim Whitespace";
			// 
			// BatchOptions
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(332, 181);
			this.ControlBox = false;
			this.Controls.Add(this.whitespaceCheckBox);
			this.Controls.Add(this.cancelButton);
			this.Controls.Add(this.OKButton);
			this.Controls.Add(this.PrintCheckBox);
			this.Controls.Add(this.sizeCheckBox);
			this.Controls.Add(this.FontSizeLabel);
			this.Controls.Add(this.sizeTextBox);
			this.Controls.Add(this.label1);
			this.Name = "BatchOptions";
			this.Text = "Batch Options";
			this.Load += new System.EventHandler(this.BatchOptions_Load);
			this.ResumeLayout(false);

		}
		#endregion

		private void sizeCheckBox_CheckedChanged(object sender, System.EventArgs e)
		{
			if (sizeCheckBox.Checked)
			{
				this.sizeTextBox.Enabled = true;
				this.FontSizeLabel.Enabled = true;
			}
			else
			{
				this.sizeTextBox.Enabled = false;
				this.FontSizeLabel.Enabled = false;
			}
		}


		private void OKButton_Click(object sender, System.EventArgs e)
		{
			if (sizeCheckBox.Checked)
			{
				try
				{
					SampleFrame.newFontSize = Int32.Parse(this.sizeTextBox.Text);
					if (SampleFrame.newFontSize < 6)
						throw new Exception();
				}
				catch
				{
					System.Windows.Forms.MessageBox.Show(this,"Invalid font size");
					return;
				}
			}
			
			if (PrintCheckBox.Checked)
			{
				SampleFrame.printWhileConverting = true;
			}
			if (whitespaceCheckBox.Checked)
			{
				SampleFrame.removeWhitespace = true;
			}

			this.Close();
		}

		private void BatchOptions_Load(object sender, System.EventArgs e)
		{
		
		}

		private void cancelButton_Click(object sender, System.EventArgs e)
		{
			this.Close();
		}
	}
}
