using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

namespace SampleCs
{
	/// <summary>
	/// Summary description for SampleFrame.
	/// </summary>
	public class SampleFrame : System.Windows.Forms.Form
	{
		private System.Windows.Forms.MainMenu mainMenu;
		private RichTextBoxEx richTextBoxEx;
		private System.Drawing.Printing.PrintDocument printDocument;
		private System.Windows.Forms.PrintDialog printDialog;
		private System.Windows.Forms.PrintPreviewDialog printPreviewDialog;
		private System.Windows.Forms.PageSetupDialog pageSetupDialog;
		private System.Windows.Forms.MenuItem menuFilePrintPreview;
		private System.Windows.Forms.MenuItem menuFilePrint;
		private System.Windows.Forms.MenuItem menuFile;
		private System.Windows.Forms.MenuItem menuFilePageSetup;
		private System.Windows.Forms.MenuItem menuFormat;
		private System.Windows.Forms.MenuItem menuFormatBold;
		private System.Windows.Forms.MenuItem menuFormatItalic;
		private System.Windows.Forms.MenuItem menuFontSize;
		private System.Windows.Forms.MenuItem menuFontSize8;
		private System.Windows.Forms.MenuItem menuFontSize10;
		private System.Windows.Forms.MenuItem menuFontSize12;
		private System.Windows.Forms.MenuItem menuFontSize18;
		private System.Windows.Forms.MenuItem menuFontSize24;
		private System.Windows.Forms.MenuItem menuFont;
		private System.Windows.Forms.MenuItem menuFontArial;
		private System.Windows.Forms.MenuItem menuFontCourier;
		private System.Windows.Forms.MenuItem menuFontTimes;
		private System.Windows.Forms.MenuItem menuFormatUnderlined;
		private System.Windows.Forms.MenuItem menuItem1;
		private System.Windows.Forms.MenuItem openFileMenuItem;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;
		private System.Windows.Forms.MenuItem menuItem2;
		private System.Windows.Forms.MenuItem menuItem3;
		private System.Windows.Forms.MenuItem menuItem4;
		private string currentFile = null; 

		public static int newFontSize = -1;

		public static bool removeWhitespace = false;

		private System.Windows.Forms.MenuItem menuItem5;
		public static bool printWhileConverting = false;

		public SampleFrame()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();
			
			

			
			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(SampleFrame));
			this.richTextBoxEx = new RichTextBoxEx();
			this.mainMenu = new System.Windows.Forms.MainMenu();
			this.menuFile = new System.Windows.Forms.MenuItem();
			this.openFileMenuItem = new System.Windows.Forms.MenuItem();
			this.menuFilePageSetup = new System.Windows.Forms.MenuItem();
			this.menuFilePrintPreview = new System.Windows.Forms.MenuItem();
			this.menuFilePrint = new System.Windows.Forms.MenuItem();
			this.menuItem1 = new System.Windows.Forms.MenuItem();
			this.menuItem2 = new System.Windows.Forms.MenuItem();
			this.menuItem3 = new System.Windows.Forms.MenuItem();
			this.menuItem4 = new System.Windows.Forms.MenuItem();
			this.menuItem5 = new System.Windows.Forms.MenuItem();
			this.menuFormat = new System.Windows.Forms.MenuItem();
			this.menuFormatBold = new System.Windows.Forms.MenuItem();
			this.menuFormatItalic = new System.Windows.Forms.MenuItem();
			this.menuFormatUnderlined = new System.Windows.Forms.MenuItem();
			this.menuFontSize = new System.Windows.Forms.MenuItem();
			this.menuFontSize8 = new System.Windows.Forms.MenuItem();
			this.menuFontSize10 = new System.Windows.Forms.MenuItem();
			this.menuFontSize12 = new System.Windows.Forms.MenuItem();
			this.menuFontSize18 = new System.Windows.Forms.MenuItem();
			this.menuFontSize24 = new System.Windows.Forms.MenuItem();
			this.menuFont = new System.Windows.Forms.MenuItem();
			this.menuFontArial = new System.Windows.Forms.MenuItem();
			this.menuFontCourier = new System.Windows.Forms.MenuItem();
			this.menuFontTimes = new System.Windows.Forms.MenuItem();
			this.printDocument = new System.Drawing.Printing.PrintDocument();
			this.printDialog = new System.Windows.Forms.PrintDialog();
			this.printPreviewDialog = new System.Windows.Forms.PrintPreviewDialog();
			this.pageSetupDialog = new System.Windows.Forms.PageSetupDialog();
			this.SuspendLayout();
			// 
			// richTextBoxEx
			// 
			this.richTextBoxEx.AcceptsTab = true;
			this.richTextBoxEx.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.richTextBoxEx.Location = new System.Drawing.Point(0, 0);
			this.richTextBoxEx.Name = "richTextBoxEx";
			this.richTextBoxEx.Size = new System.Drawing.Size(400, 235);
			this.richTextBoxEx.TabIndex = 0;
			this.richTextBoxEx.TabStop = false;
			this.richTextBoxEx.Text = "";
			this.richTextBoxEx.WordWrap = false;
			// 
			// mainMenu
			// 
			this.mainMenu.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					 this.menuFile,
																					 this.menuFormat});
			// 
			// menuFile
			// 
			this.menuFile.Index = 0;
			this.menuFile.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					 this.menuItem4,
																					 this.menuItem5,
																					 this.openFileMenuItem,
																					 this.menuFilePageSetup,
																					 this.menuFilePrintPreview,
																					 this.menuFilePrint,
																					 this.menuItem1,
																					 this.menuItem2,
																					 this.menuItem3});
			this.menuFile.Text = "&File";
			// 
			// openFileMenuItem
			// 
			this.openFileMenuItem.Index = 2;
			this.openFileMenuItem.Text = "Open File";
			this.openFileMenuItem.Click += new System.EventHandler(this.openFileMenuItem_Click);
			// 
			// menuFilePageSetup
			// 
			this.menuFilePageSetup.Index = 3;
			this.menuFilePageSetup.Text = "Page &Setup...";
			this.menuFilePageSetup.Click += new System.EventHandler(this.menuFilePageSetup_Click);
			// 
			// menuFilePrintPreview
			// 
			this.menuFilePrintPreview.Index = 4;
			this.menuFilePrintPreview.Text = "Print Pre&view...";
			this.menuFilePrintPreview.Click += new System.EventHandler(this.menuFilePrintPreview_Click);
			// 
			// menuFilePrint
			// 
			this.menuFilePrint.Index = 5;
			this.menuFilePrint.Text = "&Print...";
			this.menuFilePrint.Click += new System.EventHandler(this.menuFilePrint_Click);
			// 
			// menuItem1
			// 
			this.menuItem1.Index = 6;
			this.menuItem1.Text = "&Batch Print";
			this.menuItem1.Click += new System.EventHandler(this.menuItem1_Click);
			// 
			// menuItem2
			// 
			this.menuItem2.Index = 7;
			this.menuItem2.Text = "Save";
			this.menuItem2.Click += new System.EventHandler(this.menuItem2_Click);
			// 
			// menuItem3
			// 
			this.menuItem3.Index = 8;
			this.menuItem3.Text = "Save As";
			this.menuItem3.Click += new System.EventHandler(this.menuItem3_Click);
			// 
			// menuItem4
			// 
			this.menuItem4.Index = 0;
			this.menuItem4.Text = "Batch Processor";
			this.menuItem4.Click += new System.EventHandler(this.menuItem4_Click);
			// 
			// menuItem5
			// 
			this.menuItem5.Index = 1;
			this.menuItem5.Text = "Merge Documents";
			this.menuItem5.Click += new System.EventHandler(this.menuItem5_Click_1);
			// 
			// menuFormat
			// 
			this.menuFormat.Index = 1;
			this.menuFormat.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					   this.menuFormatBold,
																					   this.menuFormatItalic,
																					   this.menuFormatUnderlined,
																					   this.menuFontSize,
																					   this.menuFont});
			this.menuFormat.Text = "F&ormat";
			// 
			// menuFormatBold
			// 
			this.menuFormatBold.Index = 0;
			this.menuFormatBold.Text = "&Bold";
			this.menuFormatBold.Click += new System.EventHandler(this.menuFormatBold_Click);
			// 
			// menuFormatItalic
			// 
			this.menuFormatItalic.Index = 1;
			this.menuFormatItalic.Text = "&Italic";
			this.menuFormatItalic.Click += new System.EventHandler(this.menuFormatItalic_Click);
			// 
			// menuFormatUnderlined
			// 
			this.menuFormatUnderlined.Index = 2;
			this.menuFormatUnderlined.Text = "&Underlined";
			this.menuFormatUnderlined.Click += new System.EventHandler(this.menuFormatUnderlined_Click);
			// 
			// menuFontSize
			// 
			this.menuFontSize.Index = 3;
			this.menuFontSize.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																						 this.menuFontSize8,
																						 this.menuFontSize10,
																						 this.menuFontSize12,
																						 this.menuFontSize18,
																						 this.menuFontSize24});
			this.menuFontSize.Text = "Font &Size";
			// 
			// menuFontSize8
			// 
			this.menuFontSize8.Index = 0;
			this.menuFontSize8.Text = "8";
			this.menuFontSize8.Click += new System.EventHandler(this.menuFontSize8_Click);
			// 
			// menuFontSize10
			// 
			this.menuFontSize10.Index = 1;
			this.menuFontSize10.Text = "10";
			this.menuFontSize10.Click += new System.EventHandler(this.menuFontSize10_Click);
			// 
			// menuFontSize12
			// 
			this.menuFontSize12.Index = 2;
			this.menuFontSize12.Text = "12";
			this.menuFontSize12.Click += new System.EventHandler(this.menuFontSize12_Click);
			// 
			// menuFontSize18
			// 
			this.menuFontSize18.Index = 3;
			this.menuFontSize18.Text = "18";
			this.menuFontSize18.Click += new System.EventHandler(this.menuFontSize18_Click);
			// 
			// menuFontSize24
			// 
			this.menuFontSize24.Index = 4;
			this.menuFontSize24.Text = "24";
			this.menuFontSize24.Click += new System.EventHandler(this.menuFontSize24_Click);
			// 
			// menuFont
			// 
			this.menuFont.Index = 4;
			this.menuFont.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					 this.menuFontArial,
																					 this.menuFontCourier,
																					 this.menuFontTimes});
			this.menuFont.Text = "&Font";
			// 
			// menuFontArial
			// 
			this.menuFontArial.Index = 0;
			this.menuFontArial.Text = "Arial";
			this.menuFontArial.Click += new System.EventHandler(this.menuFontArial_Click);
			// 
			// menuFontCourier
			// 
			this.menuFontCourier.Index = 1;
			this.menuFontCourier.Text = "Courier";
			this.menuFontCourier.Click += new System.EventHandler(this.menuFontCourier_Click);
			// 
			// menuFontTimes
			// 
			this.menuFontTimes.Index = 2;
			this.menuFontTimes.Text = "Times New Roman";
			this.menuFontTimes.Click += new System.EventHandler(this.menuFontTimes_Click);
			// 
			// printDocument
			// 
			this.printDocument.BeginPrint += new System.Drawing.Printing.PrintEventHandler(this.printDocument_BeginPrint);
			this.printDocument.EndPrint += new System.Drawing.Printing.PrintEventHandler(this.printDocument_EndPrint);
			this.printDocument.PrintPage += new System.Drawing.Printing.PrintPageEventHandler(this.printDocument_PrintPage);
			// 
			// printDialog
			// 
			this.printDialog.Document = this.printDocument;
			// 
			// printPreviewDialog
			// 
			this.printPreviewDialog.AutoScrollMargin = new System.Drawing.Size(0, 0);
			this.printPreviewDialog.AutoScrollMinSize = new System.Drawing.Size(0, 0);
			this.printPreviewDialog.ClientSize = new System.Drawing.Size(400, 300);
			this.printPreviewDialog.Document = this.printDocument;
			this.printPreviewDialog.Enabled = true;
			this.printPreviewDialog.Icon = ((System.Drawing.Icon)(resources.GetObject("printPreviewDialog.Icon")));
			this.printPreviewDialog.Location = new System.Drawing.Point(132, 132);
			this.printPreviewDialog.MinimumSize = new System.Drawing.Size(375, 250);
			this.printPreviewDialog.Name = "printPreviewDialog";
			this.printPreviewDialog.TransparencyKey = System.Drawing.Color.Empty;
			this.printPreviewDialog.Visible = false;
			// 
			// pageSetupDialog
			// 
			this.pageSetupDialog.Document = this.printDocument;
			// 
			// SampleFrame
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(400, 233);
			this.Controls.Add(this.richTextBoxEx);
			this.Menu = this.mainMenu;
			this.Name = "SampleFrame";
			this.Text = "PUC IT\'s Rich Text Utility";
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new SampleFrame());
		}

		private int m_nFirstCharOnPage;

		private void printDocument_BeginPrint(object sender, System.Drawing.Printing.PrintEventArgs e)
		{
			// Start at the beginning of the text
			m_nFirstCharOnPage = 0;
		}

		private void printDocument_PrintPage(object sender, System.Drawing.Printing.PrintPageEventArgs e)
		{
			// To print the boundaries of the current page margins
			// uncomment the next line:
			//e.Graphics.DrawRectangle(System.Drawing.Pens.Blue, e.MarginBounds);
    
			// make the RichTextBoxEx calculate and render as much text as will
			// fit on the page and remember the last character printed for the
			// beginning of the next page
			m_nFirstCharOnPage = richTextBoxEx.FormatRange(false,
				e,
				m_nFirstCharOnPage,
				richTextBoxEx.TextLength);

			// check if there are more pages to print
			if (m_nFirstCharOnPage < richTextBoxEx.TextLength)
				e.HasMorePages = true;
			else
				e.HasMorePages = false;
		}

		private void printDocument_EndPrint(object sender, System.Drawing.Printing.PrintEventArgs e)
		{
			// Clean up cached information
			richTextBoxEx.FormatRangeDone();
		}

		private void menuFilePageSetup_Click(object sender, System.EventArgs e)
		{
			pageSetupDialog.ShowDialog();
		}

		private void menuFilePrintPreview_Click(object sender, System.EventArgs e)
		{
			if (printPreviewDialog.ShowDialog() == DialogResult.OK)
				printDocument.Print();
		}

		private void menuFilePrint_Click(object sender, System.EventArgs e)
		{
			printDocument.Print();
		}

		private void menuFormatBold_Click(object sender, System.EventArgs e)
		{
			richTextBoxEx.SetSelectionBold(true);		
		}

		private void menuFormatItalic_Click(object sender, System.EventArgs e)
		{
			richTextBoxEx.SetSelectionItalic(true);
		}

		private void menuFormatUnderlined_Click(object sender, System.EventArgs e)
		{
			richTextBoxEx.SetSelectionUnderlined(true);
		}

		private void menuFontSize8_Click(object sender, System.EventArgs e)
		{
			richTextBoxEx.SetSelectionSize(8);
		}

		private void menuFontSize10_Click(object sender, System.EventArgs e)
		{
			richTextBoxEx.SetSelectionSize(10);
		}

		private void menuFontSize12_Click(object sender, System.EventArgs e)
		{
			richTextBoxEx.SetSelectionSize(12);
		}

		private void menuFontSize18_Click(object sender, System.EventArgs e)
		{
			richTextBoxEx.SetSelectionSize(18);
		}

		private void menuFontSize24_Click(object sender, System.EventArgs e)
		{	
			richTextBoxEx.SetSelectionSize(24);
		}

		private void menuFontArial_Click(object sender, System.EventArgs e)
		{
			richTextBoxEx.SetSelectionFont("Arial");
		}

		private void menuFontCourier_Click(object sender, System.EventArgs e)
		{
			richTextBoxEx.SetSelectionFont("Courier New");
		}

		private void menuFontTimes_Click(object sender, System.EventArgs e)
		{
			richTextBoxEx.SetSelectionFont("Times New Roman");
		}

		private void menuItem1_Click(object sender, System.EventArgs e)
		{
			try
			{
				System.Windows.Forms.OpenFileDialog fileChooser = new System.Windows.Forms.OpenFileDialog();
				//fileChooser.Filter = "RTF files (*.rtf)|*.rtf";
			
				fileChooser.Title = "Please select all the files you want to print.";
			
				fileChooser.Multiselect = true;

				if (System.Windows.Forms.DialogResult.OK == fileChooser.ShowDialog())
				{

					pageSetupDialog.ShowDialog();

					foreach (String s in fileChooser.FileNames)
					{
						richTextBoxEx.LoadFile(s);
						richTextBoxEx.SelectAll();
						richTextBoxEx.SetSelectionSize(8);
						printDocument.Print();
				
				
					}
				}
			}
			catch (Exception e6)
			{
				System.Windows.Forms.MessageBox.Show(this,"There was an error printing one or more of the documents you specified. Please check that the printer you selected is online, and that all documents are correctly formated. " + e6.ToString());
			}
			richTextBoxEx.Clear();
			this.currentFile = null;
		}

		private void openFileMenuItem_Click(object sender, System.EventArgs e)
		{
			richTextBoxEx.AcceptsTab = true;
			
			try
			{
				System.Windows.Forms.OpenFileDialog fileChooser = new System.Windows.Forms.OpenFileDialog();
				//fileChooser.Filter = "RTF files (*.rtf)|*.rtf";
				fileChooser.Multiselect = false;
			
				if (System.Windows.Forms.DialogResult.OK == fileChooser.ShowDialog())
				{
					System.IO.FileInfo f = new System.IO.FileInfo(fileChooser.FileName);
					
					try
					{
						richTextBoxEx.LoadFile(fileChooser.FileName);
					}
					catch
					{
						//this.convertToRTF(fileChooser.FileName);
						richTextBoxEx.Clear();
						
						System.IO.StreamReader reader = new System.IO.StreamReader(fileChooser.FileName,System.Text.Encoding.ASCII);
						richTextBoxEx.Text = reader.ReadToEnd();
						reader.Close();
						//richTextBoxEx.AcceptsTab = true;
						//richTextBoxEx.TabStop = false;
						

						//richTextBoxEx.LoadFile(fileChooser.FileName,System.Windows.Forms.RichTextBoxStreamType.PlainText);
						//System.Windows.Forms.RichTextBoxStreamType.RichText;
						///throw new Exception();
					}
					this.currentFile = fileChooser.FileName;
					richTextBoxEx.SelectAll();
					richTextBoxEx.SetSelectionFont("Courier New");

				}
			}
			catch (Exception e5)
			{
				System.Windows.Forms.MessageBox.Show(this,"Error: " + e5.ToString());
			}
		}
		
		private void save()
		{
			if (currentFile != null)
				richTextBoxEx.SaveFile(currentFile);
			else
			{
				System.Windows.Forms.SaveFileDialog f = new SaveFileDialog();
				f.Filter = "RTF files (*.rtf)|*.rtf";
				if (System.Windows.Forms.DialogResult.OK == f.ShowDialog(this))
				{
					richTextBoxEx.SaveFile(f.FileName);
					currentFile = f.FileName;
				}

			}
			
		}

		private void menuItem2_Click(object sender, System.EventArgs e)
		{
			save();
		}

		private void menuItem3_Click(object sender, System.EventArgs e)
		{
			System.Windows.Forms.SaveFileDialog f = new SaveFileDialog();
			f.Filter = "RTF files (*.rtf)|*.rtf";
			if (System.Windows.Forms.DialogResult.OK == f.ShowDialog(this))
			{
				richTextBoxEx.SaveFile(f.FileName);
				currentFile = f.FileName;
			}
		}

		private void menuItem4_Click(object sender, System.EventArgs e)
		{
			try
			{
				BatchOptions b = new BatchOptions();
				b.ShowDialog(this);
				if (!printWhileConverting && newFontSize == -1 && !removeWhitespace)
					return;

				System.Windows.Forms.OpenFileDialog fileChooser = new System.Windows.Forms.OpenFileDialog();
				fileChooser.Filter = "All Files|*";
				fileChooser.Multiselect = true;
			
				if (printWhileConverting)
					pageSetupDialog.ShowDialog();

				if (System.Windows.Forms.DialogResult.OK == fileChooser.ShowDialog())
				{
					foreach (string filename in fileChooser.FileNames)
					{
						try
						{
							richTextBoxEx.LoadFile(filename);
							//richTextBoxEx.LoadFile(filename,System.Windows.Forms.RichTextBoxStreamType.PlainText);
						}
						catch
						{	
							try
							{
								richTextBoxEx.Clear();
								System.IO.StreamReader reader = new System.IO.StreamReader(filename,System.Text.Encoding.ASCII);
								richTextBoxEx.Text = reader.ReadToEnd();
								reader.Close();
								richTextBoxEx.SelectAll();
								richTextBoxEx.SetSelectionFont("Courier New");
							}
							catch
							{
								System.Windows.Forms.MessageBox.Show(this,"Error opening file: " + filename);
								return;
							}
							
							
						}

						

						richTextBoxEx.SelectAll();
					
						if (newFontSize != -1)
							richTextBoxEx.SetSelectionSize(newFontSize);
					
						if (removeWhitespace)
							richTextBoxEx.Text = richTextBoxEx.Text.Trim();

						richTextBoxEx.SetSelectionFont("Courier New");

						if (printWhileConverting)
							printDocument.Print();
			
						if (newFontSize != -1 || removeWhitespace)
						{
							String fileNameToSaveAs = filename;
							fileNameToSaveAs = fileNameToSaveAs.Replace(".txt","");
							fileNameToSaveAs = fileNameToSaveAs.Replace(".rtf","");
							fileNameToSaveAs = fileNameToSaveAs + ".rtf";

							richTextBoxEx.SaveFile(fileNameToSaveAs);
							

							/*foreach (int i in oldTabs)
								System.Console.WriteLine(i + " ");
							*/
						}
					
					}
					currentFile = null;
				}
				
				richTextBoxEx.Clear();
				System.Windows.Forms.MessageBox.Show(this,"Conversion Complete");
				
			}
			catch (Exception e5)
			{
				System.Windows.Forms.MessageBox.Show(this,"Error: " + e5.ToString());
			}
		}

		

		private void menuItem5_Click_1(object sender, System.EventArgs e)
		{
			try
			{
				System.Windows.Forms.OpenFileDialog fileChooser = new System.Windows.Forms.OpenFileDialog();
							
				fileChooser.Title = "Please select all the files you want to merge.";
			
				fileChooser.Multiselect = true;

				if (System.Windows.Forms.DialogResult.OK == fileChooser.ShowDialog())
				{

					string [] fileNames = fileChooser.FileNames;
					System.Array.Sort(fileNames);
					if (fileNames.Length != 0)
					{
						System.Windows.Forms.SaveFileDialog fileSaver = new SaveFileDialog();
						fileSaver.Title = "Save the files as:";
						fileSaver.Filter = "RTF format (*.rtf)|*.rtf";
						fileSaver.FileName = fileNames[0];
						
						RichTextBoxEx temp = new RichTextBoxEx();
					
						if (System.Windows.Forms.DialogResult.OK == fileSaver.ShowDialog())
						{
							
							richTextBoxEx.Clear();
							
	
							foreach (String s in fileNames)
							{
								try
								{
									temp.Clear();
									temp.LoadFile(s);
								}
								catch
								{
									System.IO.StreamReader r = new System.IO.StreamReader(s,System.Text.Encoding.ASCII);
									temp.Text = r.ReadToEnd();
									r.Close();
								}
								
								richTextBoxEx.Text += temp.Text;

								
							}
							
							richTextBoxEx.SelectAll();
							richTextBoxEx.SetSelectionFont("Courier New");
							richTextBoxEx.SaveFile(fileSaver.FileName);
							currentFile = fileSaver.FileName;
							System.Windows.Forms.MessageBox.Show(this,"Merging Complete");
						}
					}
				}
			}
			catch (Exception e6)
			{
				System.Windows.Forms.MessageBox.Show(this,"There was an error printing one or more of the documents you specified. Please check that the printer you selected is online, and that all documents are correctly formated. " + e6.ToString());
			}
		}
	}
}
